#!/usr/pub/bin/perl5.00404 
# get_seq_rep.pl
#
# Miguel A. Andrade
# June 1999


$organism = $ARGV[0];
$id = $ARGV[1];

%db = (
       'CE', 'db/worm',
       'SC', 'db/S.cerevisiae.fasta',
       'HS', 'db/hs_swiss97',
);


# get the sequence

$get = 0;
open(DB, $db{$organism});
while(<DB>){
  if ($get == 0) {
    if (/^\>/){
      if (/$id/) {
	$get = 1;
	$id_line = $_;
      }
    }
    next;
  } else {
    if (/^\>/){
      $get = 0;
      next;
    }

    $sequence .= $_;
  }
}
close(<DB>);


$sequence =~ s/\n//g;
$sequence =~ s/\s//g;



# output

print "Content-type: text/html\n\n";
print "<BODY BGCOLOR=#FFFFFF TEXT=#008800 LINK=#808800>\n";
print "<TITLE>Sequence $id from $organism</TITLE>\n";

print "<H3>Sequence $id from $organism</H3>\n";

# make a nice 60 column format
print "<PRE>$id_line";

$i = 0;
while ($i < (length($sequence) - 60)) {
  $subseq = substr($sequence, $i, 60);
  print "$subseq\n";
  $i += 60;
}
$subseq = substr($sequence, $i, length($sequence));
print "$subseq\n";


print "</PRE>\n";


print "<HR>\n";
print "<A HREF=http://www.embl-heidelberg.de/~andrade/papers/rep/>[Appendix Home]</A>\n";
print "<A HREF=http://www.embl-heidelberg.de/~andrade/index.html>[Andrade Home]</A>\n";
print "<A HREF=http://www.bork.embl-heidelberg.de/>[Bork Group]</A>\n";
