        
        $('.tddiv').hover(function(){
            var index = $(this).closest('tr').children().index($(this).closest('td'));
            var window_length = parseInt($(this).closest('table').closest('tr').children().first().children().first().text());
            var list1 = $(this).closest('tr').children();
            var list2 = $(this).closest('tr').next().children();    
            
            if (list1.length < window_length) {
				list2 = $(this).closest('tr').children();
				list1 = $(this).closest('tr').prev().children();
				index = list1.length-1;
            }
            
            if (index + window_length > list1.length + list2.length)
                index = list1.length + list2.length - window_length;
            list1.slice(index, index + window_length).addClass("amino-acid-hover");
            if (index + window_length > list1.length) {
                var list2 = list2.slice(0, index + window_length - list1.length);
                list2.addClass("amino-acid-hover");
            }
            
            }, function(){
            $(".amino-acid-hover").removeClass("amino-acid-hover");
		});        
        $(function () {
			$('[data-toggle="tooltip"]').tooltip()
        })
        function textAreaOnKeyUp() {
            var seq = $("#inputSeqTextArea").val().toUpperCase();
            var seqIsValid = true;            

            i = 0;
            // Skipping Description line
            if (seq[0] == ">")
            while ((i < seq.length) && (seq.charCodeAt(i) != 10) && (seq.charCodeAt(i) != 13)) {
                i++;
            }
            // Skipping line return
            while ((i < seq.length) && ((seq.charCodeAt(i) == 10) || (seq.charCodeAt(i) == 13))) {
                i++;
            }
            // Taking only the first sequence until ">" is encoutered
            while ((i < seq.length) && (seq[i] != ">") && seqIsValid) {
                if ((seq.charCodeAt(i) != 10) && (seq.charCodeAt(i) != 13) && (seq[i] != '-') && !((seq[i] >= 'A') && (seq[i] <= 'Z') && (seq[i] != 'B') && (seq[i] != 'J') && (seq[i] != 'O') && (seq[i] != 'U') && (seq[i] != 'X') && (seq[i] != 'Z')) )
                    seqIsValid = false;
                i++;
            }

            if (!seqIsValid) {
                $("#message").slideDown();
                $("#message").text("Your sequence is invalid!");
            } else {
                $("#message").slideUp();
            }
            if (seq.length == 0)
				$("#clearSeq").hide();
			else
				$("#clearSeq").show();
        }
        function resetButtonOnKeyUp() {
			$("#identifier").val("");
			$("#inputSeqTextArea").val("");
			$("#minWindowLength").val("20");
			$("#maxWindowLength").val("20");
			$("#minMotifLength").val("1");
			$("#maxMotifLength").val("10");
			$("#minMutations").val("0");
			$("#maxMutations").val("10");
			textAreaOnKeyUp();
        }
        $(document).ready(function() {
			$("#identifier").val("");
			//$("#inputSeqTextArea").val("");
			if ($("#results").length)
				$('html, body').animate({
					scrollTop: $("#results").offset().top
				}, 2000);
			
        $("#citeButton").hover(function(){
			$("#citeDropDownList").slideDown();
        },function(){
			$("#citeDropDownList").delay(2000).slideUp();
        });

        
		});

		function submitIfReturn(e) {
			if (e.keyCode == 13)
				submitSeq();
            //alert("oooo");
		}
        function submitSeq() {
            //alert("oooo");
            if (($("#identifier").val() != "") && ($("#inputSeqTextArea").val() == "")) {
                $("#fetchMessage").html("Retrieving protein sequence from UniProt, please wait ...");
                $("#fetchMessage").addClass("fetchDefault");
                $("#fetchMessage" ).show();
                var jqxhr = $.get( "https://www.uniprot.org/uniprot/"+$("#identifier").val()+".fasta", function(data, statusText, xhr) {
                    })
                    .done(function(data, statusText, xhr) {
                        $("#inputSeqTextArea").val(data);
                        $("#fetchMessage").html("Retrieve succeeded");
						$("#fetchMessage").removeClass("fetchDefault");
                        $("#fetchMessage").addClass("fetchSuccess");
                        $("#fetchMessage" ).delay(3000).fadeOut( "slow");
                        //$("#submitSeqForm").submit();
						submitSeqAjax();
						
                    })
                    .fail(function(data, statusText, xhr) {
                        $("#fetchMessage").html("Retrieve failed");
						$("#fetchMessage").removeClass("fetchDefault");
                        $("#fetchMessage").addClass("fetchFail");
                        $("#fetchMessage" ).delay(3000).fadeOut( "slow");
                    })
                    .always(function() {
					$("#inputSeqTextArea").val("");
                    });
            } else if (($("#identifier").val() == "") && ($("#inputSeqTextArea").val() != "")) {
                        //$("#submitSeqForm").submit();
						submitSeqAjax();
                    } else {
                        $("#message").slideDown();
                        $("#message").text("Please put either an identifier or a sequence !");
                    }
        }
        //$( "#submitButton" ).click(function(event) {
        //    alert( "Handler for .click() called." );
        //    return false;
        //});
        function clearInputSequence() {
			$("#inputSeqTextArea").val("");
			textAreaOnKeyUp();
        }


function submitSeqAjax(){
	$oldText = $("#submitButton").html();
	$("#submitButton").html("Searching ...");
	$("#submitButton").attr("disabled", true);
	$('#relustAreaSpinner').show();
	//document.domain = "https://cbdm-01.zdv.uni-mainz.de";
	$.ajax({
	//url: 'http://cbdm-01.zdv.uni-mainz.de/~munoz/cgi-bin/rep/search3.pl',
	url: 'search3.pl',
	type: 'post',
	data: {
		sequence: $("#inputSeqTextArea").val(),
		all: $("#all").is(":checked")?"1":"0",
		format: "html",//$("#outputFormat").children("option:selected").val(),
		repeat_type: $("#repeat-type").children("option:selected").val()
	},
	headers: {
		"Content-Type": "application/x-www-form-urlencoded"
	},
	success: function (data) {
		$('#submitButton').removeAttr("disabled");
		$("#submitButton").html("Search for repeats");
		$("#resultArea").html(data);
		$('html, body').animate({
			scrollTop: $("#resultArea").offset().top
		}, 2000);
	},
	error: function(XMLHttpRequest, textStatus, errorThrown) { 
		$('#submitButton').removeAttr("disabled");
		$("#submitButton").html("Search for repeats");
		$("#resultArea").html("Status: " + textStatus + "<br/>Error: " + errorThrown);
		$('html, body').animate({
			scrollTop: $("#resultArea").offset().top
		}, 2000);
    }       

	});
  
};

function download_csv(csv, filename) {
    var csvFile;
    var downloadLink;

    // CSV FILE
    csvFile = new Blob([csv], {type: "text/csv"});

    // Download link
    downloadLink = document.createElement("a");

    // File name
    downloadLink.download = filename;

    // We have to create a link to the file
    downloadLink.href = window.URL.createObjectURL(csvFile);

    // Make sure that the link is not displayed
    downloadLink.style.display = "none";

    // Add the link to your DOM
    document.body.appendChild(downloadLink);

    // Lanzamos
    downloadLink.click();
}

function export_table_to_csv(html, filename) {
	table_number = 0;

	var csv = [];

	while (t = document.querySelector("#result-table-" + table_number)) {

		row = [];
		html = t.outerHTML;
		var rows = t.querySelectorAll("tr");
		for (var i = table_number==0?0:1; i < rows.length; i++) {
			var row = [], cols = rows[i].querySelectorAll("td, th");
			
			row.push((i == 0) ? "Sequence name":document.querySelector("#seq-name-"+table_number).innerText);
			
			for (var j = 0; j < cols.length; j++) 
				row.push(cols[j].innerText);
			
			csv.push(row.join("\t"));
		}
		table_number++;
	}

    // Download CSV
    download_csv(csv.join("\n"), filename);
}
