#!/usr/bin/perl
# get_info.pl
#
# Miguel A. Andrade
# July 1999


$repeat = $ARGV[0];

$ALN_DIR = "alignments/";

%files = (
       'ANK','ank2',
       'ARM', 'arm',
       'HAT','hat',
       'HEAT','heat',
       'HEAT_AAA','heat_aaa',
       'HEAT_ADB','heat_adb',
       'HEAT_IMB','heat_imb',
       'KELCH','kelch_2',
       'LRR','lrr2_50',
       'PFTA','pfta_sw',
       'PFTB','pftb3',
       'RCC1','rcc1',
       'TPR','tpr',
       'WD40','wd3_nr',
);


# get the alignment

$file_name = $ALN_DIR.$files{$repeat}.'.aln';
$alignment = `cat $file_name`;

# output

print "Content-type: text/html\n\n";
print "<BODY BGCOLOR=#FFFFFF TEXT=#008800 LINK=#808800>\n";
print "<TITLE>Alignment of $repeat repeats</TITLE>\n";

print "<H3>Alignment of $repeat repeats</H3>\n";

print "<PRE>\n";
print "$alignment";
print "</PRE>\n";


print "<HR>\n";
print "<A HREF=http://www.embl-heidelberg.de/~andrade/papers/rep/>[Appendix Home]</A>\n";
print "<A HREF=http://www.embl-heidelberg.de/~andrade/index.html>[Andrade Home]</A>\n";
print "<A HREF=http://www.bork.embl-heidelberg.de/>[Bork Group]</A>\n";
